"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _useEventCallback = _interopRequireDefault(require("@restart/hooks/useEventCallback"));
var _useClickOutside = _interopRequireDefault(require("./useClickOutside"));
var _utils = require("../../utils");
function useRootClose(onRootClose, options) {
  var ref = (0, _react.useRef)(null);
  var onClose = onRootClose || _utils.noop;
  (0, _useClickOutside["default"])(ref, onClose, options);
  var handleKeyUp = (0, _useEventCallback["default"])(function (e) {
    if (e.key === 'Escape') {
      onClose(e);
    }
  });
  (0, _react.useEffect)(function () {
    var _ref$current;
    if (options.disabled || ref == null) return undefined;
    var doc = ((_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.ownerDocument) || document;

    // Store the current event to avoid triggering handlers immediately
    // https://github.com/facebook/react/issues/20074
    var currentEvent = (doc.defaultView || window).event;
    var onKeyUp = function onKeyUp(e) {
      // skip if this event is the same as the one running when we added the handlers
      if (e === currentEvent) {
        currentEvent = undefined;
        return;
      }
      handleKeyUp(e);
    };
    doc.addEventListener('keyup', onKeyUp);
    return function () {
      doc.removeEventListener('keyup', onKeyUp);
    };
  }, [ref, options.disabled, handleKeyUp]);
  return ref;
}
var _default = exports["default"] = useRootClose;